HttpServletRequestWrapper (Servlet 4.0 API Documentation - Apache Tomcat 9.0.37)

javax.servlet.http

## Class HttpServletRequestWrapper

- java.lang.Object
- - javax.servlet.ServletRequestWrapper
  - - javax.servlet.http.HttpServletRequestWrapper

- All Implemented Interfaces:
    HttpServletRequest, ServletRequest

      public class HttpServletRequestWrapper
      extends ServletRequestWrapper
      implements HttpServletRequest

  Provides a convenient implementation of the HttpServletRequest interface that can be subclassed by developers wishing to adapt the request to a Servlet. This class implements the Wrapper or Decorator pattern. Methods default to calling through to the wrapped request object.
  Since:
    v 2.3
  See Also:
    `HttpServletRequest`

- - ### Field Summary

    - ### Fields inherited from interface javax.servlet.http.HttpServletRequest

      `BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HttpServletRequestWrapper(HttpServletRequest request)` Constructs a request object wrapping the given request.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `authenticate(HttpServletResponse response)` Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.
    `java.lang.String` | `changeSessionId()` The default behavior of this method is to call changeSessionId() on the wrapped request object.
    `java.lang.String` | `getAuthType()` The default behavior of this method is to return getAuthType() on the wrapped request object.
    `java.lang.String` | `getContextPath()` The default behavior of this method is to return getContextPath() on the wrapped request object.
    `Cookie[]` | `getCookies()` The default behavior of this method is to return getCookies() on the wrapped request object.
    `long` | `getDateHeader(java.lang.String name)` The default behavior of this method is to return getDateHeader(String name) on the wrapped request object.
    `java.lang.String` | `getHeader(java.lang.String name)` The default behavior of this method is to return getHeader(String name) on the wrapped request object.
    `java.util.Enumeration<java.lang.String>` | `getHeaderNames()` The default behavior of this method is to return getHeaderNames() on the wrapped request object.
    `java.util.Enumeration<java.lang.String>` | `getHeaders(java.lang.String name)` The default behavior of this method is to return getHeaders(String name) on the wrapped request object.
    `HttpServletMapping` | `getHttpServletMapping()` The default behavior of this method is to return `HttpServletRequest.getHttpServletMapping()` on the wrapped request object.
    `int` | `getIntHeader(java.lang.String name)` The default behavior of this method is to return getIntHeader(String name) on the wrapped request object.
    `java.lang.String` | `getMethod()` The default behavior of this method is to return getMethod() on the wrapped request object.
    `Part` | `getPart(java.lang.String name)` Gets the named Part or null if the Part does not exist.
    `java.util.Collection<Part>` | `getParts()` Return a collection of all uploaded Parts.
    `java.lang.String` | `getPathInfo()` The default behavior of this method is to return getPathInfo() on the wrapped request object.
    `java.lang.String` | `getPathTranslated()` The default behavior of this method is to return getPathTranslated() on the wrapped request object.
    `java.lang.String` | `getQueryString()` The default behavior of this method is to return getQueryString() on the wrapped request object.
    `java.lang.String` | `getRemoteUser()` The default behavior of this method is to return getRemoteUser() on the wrapped request object.
    `java.lang.String` | `getRequestedSessionId()` The default behavior of this method is to return getRequestedSessionId() on the wrapped request object.
    `java.lang.String` | `getRequestURI()` The default behavior of this method is to return getRequestURI() on the wrapped request object.
    `java.lang.StringBuffer` | `getRequestURL()` The default behavior of this method is to return getRequestURL() on the wrapped request object.
    `java.lang.String` | `getServletPath()` The default behavior of this method is to return getServletPath() on the wrapped request object.
    `HttpSession` | `getSession()` The default behavior of this method is to return getSession() on the wrapped request object.
    `HttpSession` | `getSession(boolean create)` The default behavior of this method is to return getSession(boolean create) on the wrapped request object.
    `java.util.Map<java.lang.String,java.lang.String>` | `getTrailerFields()` Obtain a Map of the trailer fields that is not backed by the request object.
    `java.security.Principal` | `getUserPrincipal()` The default behavior of this method is to return getUserPrincipal() on the wrapped request object.
    `boolean` | `isRequestedSessionIdFromCookie()` The default behavior of this method is to return isRequestedSessionIdFromCookie() on the wrapped request object.
    `boolean` | `isRequestedSessionIdFromUrl()` Deprecated. As of Version 3.0 of the Java Servlet API
    `boolean` | `isRequestedSessionIdFromURL()` The default behavior of this method is to return isRequestedSessionIdFromURL() on the wrapped request object.
    `boolean` | `isRequestedSessionIdValid()` The default behavior of this method is to return isRequestedSessionIdValid() on the wrapped request object.
    `boolean` | `isTrailerFieldsReady()` Are trailer fields ready to be read (there may still be no trailers to read).
    `boolean` | `isUserInRole(java.lang.String role)` The default behavior of this method is to return isUserInRole(String role) on the wrapped request object.
    `void` | `login(java.lang.String username, java.lang.String password)` Authenticate the provided user name and password and then associated the authenticated user with the request.
    `void` | `logout()` Removes any authenticated user from the request.
    `PushBuilder` | `newPushBuilder()` Obtain a builder for generating push requests.
    `<T extends HttpUpgradeHandler> T` | `upgrade(java.lang.Class<T> httpUpgradeHandlerClass)` Start the HTTP upgrade process and pass the connection to the provided protocol handler once the current request/response pair has completed processing.

    - ### Methods inherited from class javax.servlet.ServletRequestWrapper

      `getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentLengthLong, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequest, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, isWrapperFor, isWrapperFor, removeAttribute, setAttribute, setCharacterEncoding, setRequest, startAsync, startAsync`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.servlet.ServletRequest

      `getAsyncContext, getAttribute, getAttributeNames, getCharacterEncoding, getContentLength, getContentLengthLong, getContentType, getDispatcherType, getInputStream, getLocalAddr, getLocale, getLocales, getLocalName, getLocalPort, getParameter, getParameterMap, getParameterNames, getParameterValues, getProtocol, getReader, getRealPath, getRemoteAddr, getRemoteHost, getRemotePort, getRequestDispatcher, getScheme, getServerName, getServerPort, getServletContext, isAsyncStarted, isAsyncSupported, isSecure, removeAttribute, setAttribute, setCharacterEncoding, startAsync, startAsync`

- - ### Constructor Detail

    - #### HttpServletRequestWrapper

          public HttpServletRequestWrapper(HttpServletRequest request)

      Constructs a request object wrapping the given request.
      Parameters:
        `request` - The request to wrap
      Throws:
        `java.lang.IllegalArgumentException` - if the request is null

  - ### Method Detail

    - #### getAuthType

          public java.lang.String getAuthType()

      The default behavior of this method is to return getAuthType() on the wrapped request object.
      Specified by:
        `getAuthType` in interface `HttpServletRequest`
      Returns:
        one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

    - #### getCookies

          public Cookie[] getCookies()

      The default behavior of this method is to return getCookies() on the wrapped request object.
      Specified by:
        `getCookies` in interface `HttpServletRequest`
      Returns:
        an array of all the `Cookies` included with this request, or `null` if the request has no cookies

    - #### getDateHeader

          public long getDateHeader(java.lang.String name)

      The default behavior of this method is to return getDateHeader(String name) on the wrapped request object.
      Specified by:
        `getDateHeader` in interface `HttpServletRequest`
      Parameters:
        `name` - a `String` specifying the name of the header
      Returns:
        a `long` value representing the date specified in the header expressed as the number of milliseconds since January 1, 1970 GMT, or -1 if the named header was not included with the request

    - #### getHeader

          public java.lang.String getHeader(java.lang.String name)

      The default behavior of this method is to return getHeader(String name) on the wrapped request object.
      Specified by:
        `getHeader` in interface `HttpServletRequest`
      Parameters:
        `name` - a `String` specifying the header name
      Returns:
        a `String` containing the value of the requested header, or `null` if the request does not have a header of that name

    - #### getHeaders

          public java.util.Enumeration<java.lang.String> getHeaders(java.lang.String name)

      The default behavior of this method is to return getHeaders(String name) on the wrapped request object.
      Specified by:
        `getHeaders` in interface `HttpServletRequest`
      Parameters:
        `name` - a `String` specifying the header name
      Returns:
        an `Enumeration` containing the values of the requested header. If the request does not have any headers of that name return an empty enumeration. If the container does not allow access to header information, return null

    - #### getHeaderNames

          public java.util.Enumeration<java.lang.String> getHeaderNames()

      The default behavior of this method is to return getHeaderNames() on the wrapped request object.
      Specified by:
        `getHeaderNames` in interface `HttpServletRequest`
      Returns:
        an enumeration of all the header names sent with this request; if the request has no headers, an empty enumeration; if the servlet container does not allow servlets to use this method, `null`

    - #### getIntHeader

          public int getIntHeader(java.lang.String name)

      The default behavior of this method is to return getIntHeader(String name) on the wrapped request object.
      Specified by:
        `getIntHeader` in interface `HttpServletRequest`
      Parameters:
        `name` - a `String` specifying the name of a request header
      Returns:
        an integer expressing the value of the request header or -1 if the request doesn't have a header of this name

    - #### getHttpServletMapping

          public HttpServletMapping getHttpServletMapping()

      The default behavior of this method is to return `HttpServletRequest.getHttpServletMapping()` on the wrapped request object.
      Specified by:
        `getHttpServletMapping` in interface `HttpServletRequest`
      Since:
        Servlet 4.0

    - #### getMethod

          public java.lang.String getMethod()

      The default behavior of this method is to return getMethod() on the wrapped request object.
      Specified by:
        `getMethod` in interface `HttpServletRequest`
      Returns:
        a `String` specifying the name of the method with which this request was made

    - #### getPathInfo

          public java.lang.String getPathInfo()

      The default behavior of this method is to return getPathInfo() on the wrapped request object.
      Specified by:
        `getPathInfo` in interface `HttpServletRequest`
      Returns:
        a `String`, decoded by the web container, specifying extra path information that comes after the servlet path but before the query string in the request URL; or `null` if the URL does not have any extra path information

    - #### getPathTranslated

          public java.lang.String getPathTranslated()

      The default behavior of this method is to return getPathTranslated() on the wrapped request object.
      Specified by:
        `getPathTranslated` in interface `HttpServletRequest`
      Returns:
        a `String` specifying the real path, or `null` if the URL does not have any extra path information

    - #### getContextPath

          public java.lang.String getContextPath()

      The default behavior of this method is to return getContextPath() on the wrapped request object.
      Specified by:
        `getContextPath` in interface `HttpServletRequest`
      Returns:
        a `String` specifying the portion of the request URI that indicates the context of the request

    - #### getQueryString

          public java.lang.String getQueryString()

      The default behavior of this method is to return getQueryString() on the wrapped request object.
      Specified by:
        `getQueryString` in interface `HttpServletRequest`
      Returns:
        a `String` containing the query string or `null` if the URL contains no query string. The value is not decoded by the container.

    - #### getRemoteUser

          public java.lang.String getRemoteUser()

      The default behavior of this method is to return getRemoteUser() on the wrapped request object.
      Specified by:
        `getRemoteUser` in interface `HttpServletRequest`
      Returns:
        a `String` specifying the login of the user making this request, or `null` if the user login is not known

    - #### isUserInRole

          public boolean isUserInRole(java.lang.String role)

      The default behavior of this method is to return isUserInRole(String role) on the wrapped request object.
      Specified by:
        `isUserInRole` in interface `HttpServletRequest`
      Parameters:
        `role` - a `String` specifying the name of the role
      Returns:
        a `boolean` indicating whether the user making this request belongs to a given role; `false` if the user has not been authenticated

    - #### getUserPrincipal

          public java.security.Principal getUserPrincipal()

      The default behavior of this method is to return getUserPrincipal() on the wrapped request object.
      Specified by:
        `getUserPrincipal` in interface `HttpServletRequest`
      Returns:
        a `java.security.Principal` containing the name of the user making this request; `null` if the user has not been authenticated

    - #### getRequestedSessionId

          public java.lang.String getRequestedSessionId()

      The default behavior of this method is to return getRequestedSessionId() on the wrapped request object.
      Specified by:
        `getRequestedSessionId` in interface `HttpServletRequest`
      Returns:
        a `String` specifying the session ID, or `null` if the request did not specify a session ID
      See Also:
        `HttpServletRequest.isRequestedSessionIdValid()`

    - #### getRequestURI

          public java.lang.String getRequestURI()

      The default behavior of this method is to return getRequestURI() on the wrapped request object.
      Specified by:
        `getRequestURI` in interface `HttpServletRequest`
      Returns:
        a `String` containing the part of the URL from the protocol name up to the query string
      See Also:
        `HttpServletRequest.getRequestURL()`

    - #### getRequestURL

          public java.lang.StringBuffer getRequestURL()

      The default behavior of this method is to return getRequestURL() on the wrapped request object.
      Specified by:
        `getRequestURL` in interface `HttpServletRequest`
      Returns:
        a `StringBuffer` object containing the reconstructed URL

    - #### getServletPath

          public java.lang.String getServletPath()

      The default behavior of this method is to return getServletPath() on the wrapped request object.
      Specified by:
        `getServletPath` in interface `HttpServletRequest`
      Returns:
        a `String` containing the name or path of the servlet being called, as specified in the request URL, decoded, or an empty string if the servlet used to process the request is matched using the "/*" pattern.

    - #### getSession

          public HttpSession getSession(boolean create)

      The default behavior of this method is to return getSession(boolean create) on the wrapped request object.
      Specified by:
        `getSession` in interface `HttpServletRequest`
      Parameters:
        `create` - `true` to create a new session for this request if necessary; `false` to return `null` if there's no current session
      Returns:
        the `HttpSession` associated with this request or `null` if `create` is `false` and the request has no valid session
      See Also:
        `HttpServletRequest.getSession()`

    - #### getSession

          public HttpSession getSession()

      The default behavior of this method is to return getSession() on the wrapped request object.
      Specified by:
        `getSession` in interface `HttpServletRequest`
      Returns:
        the `HttpSession` associated with this request
      See Also:
        `HttpServletRequest.getSession(boolean)`

    - #### changeSessionId

          public java.lang.String changeSessionId()

      The default behavior of this method is to call changeSessionId() on the wrapped request object.
      Specified by:
        `changeSessionId` in interface `HttpServletRequest`
      Returns:
        the new session ID allocated to the session
      See Also:
        `HttpSessionIdListener`

    - #### isRequestedSessionIdValid

          public boolean isRequestedSessionIdValid()

      The default behavior of this method is to return isRequestedSessionIdValid() on the wrapped request object.
      Specified by:
        `isRequestedSessionIdValid` in interface `HttpServletRequest`
      Returns:
        `true` if this request has an id for a valid session in the current session context; `false` otherwise
      See Also:
        `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`

    - #### isRequestedSessionIdFromCookie

          public boolean isRequestedSessionIdFromCookie()

      The default behavior of this method is to return isRequestedSessionIdFromCookie() on the wrapped request object.
      Specified by:
        `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
      Returns:
        `true` if the session ID came in as a cookie; otherwise, `false`
      See Also:
        `HttpServletRequest.getSession(boolean)`

    - #### isRequestedSessionIdFromURL

          public boolean isRequestedSessionIdFromURL()

      The default behavior of this method is to return isRequestedSessionIdFromURL() on the wrapped request object.
      Specified by:
        `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
      Returns:
        `true` if the session ID came in as part of a URL; otherwise, `false`
      See Also:
        `HttpServletRequest.getSession(boolean)`

    - #### isRequestedSessionIdFromUrl

          @Deprecated
          public boolean isRequestedSessionIdFromUrl()

      Deprecated. As of Version 3.0 of the Java Servlet API
      The default behavior of this method is to return isRequestedSessionIdFromUrl() on the wrapped request object.
      Specified by:
        `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`
      Returns:
        `HttpServletRequest.isRequestedSessionIdFromURL()`

    - #### authenticate

          public boolean authenticate(HttpServletResponse response)
                               throws java.io.IOException,
                                      ServletException

      Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.

      The default behavior of this method is to return `HttpServletRequest.authenticate(HttpServletResponse)` on the wrapped request object.

      Specified by:
        `authenticate` in interface `HttpServletRequest`
      Parameters:
        `response` - The response to use to return any authentication challenge
      Returns:
        `true` if the user is successfully authenticated and `false` if not
      Throws:
        `java.io.IOException` - if the authentication process attempted to read from the request or write to the response and an I/O error occurred
        `ServletException` - if the authentication failed and the caller is expected to handle the failure
      Since:
        Servlet 3.0

    - #### login

          public void login(java.lang.String username,
                            java.lang.String password)
                     throws ServletException

      Authenticate the provided user name and password and then associated the authenticated user with the request.

      The default behavior of this method is to return `HttpServletRequest.login(String, String)` on the wrapped request object.

      Specified by:
        `login` in interface `HttpServletRequest`
      Parameters:
        `username` - The user name to authenticate
        `password` - The password to use to authenticate the user
      Throws:
        `ServletException` - If any of `HttpServletRequest.getRemoteUser()`, `HttpServletRequest.getUserPrincipal()` or `HttpServletRequest.getAuthType()` are non-null, if the configured authenticator does not support user name and password authentication or if the authentication fails
      Since:
        Servlet 3.0

    - #### logout

          public void logout()
                      throws ServletException

      Removes any authenticated user from the request.

      The default behavior of this method is to return `HttpServletRequest.logout()` on the wrapped request object.

      Specified by:
        `logout` in interface `HttpServletRequest`
      Throws:
        `ServletException` - If the logout fails
      Since:
        Servlet 3.0

    - #### getParts

          public java.util.Collection<Part> getParts()
                                              throws java.io.IOException,
                                                     ServletException

      Return a collection of all uploaded Parts.

      The default behavior of this method is to return `HttpServletRequest.getParts()` on the wrapped request object.

      Specified by:
        `getParts` in interface `HttpServletRequest`
      Returns:
        A collection of all uploaded Parts.
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `ServletException` - if the request is not multipart/form-data
      Since:
        Servlet 3.0

    - #### getPart

          public Part getPart(java.lang.String name)
                       throws java.io.IOException,
                              ServletException

      Gets the named Part or null if the Part does not exist. Triggers upload of all Parts.

      The default behavior of this method is to return `HttpServletRequest.getPart(String)` on the wrapped request object.

      Specified by:
        `getPart` in interface `HttpServletRequest`
      Parameters:
        `name` - The name of the Part to obtain
      Returns:
        The named Part or null if the Part does not exist
      Throws:
        `java.io.IOException` - if an I/O error occurs
        `ServletException` - if the request is not multipart/form-data
      Since:
        Servlet 3.0

    - #### upgrade

          public <T extends HttpUpgradeHandler> T upgrade(java.lang.Class<T> httpUpgradeHandlerClass)
                                                   throws java.io.IOException,
                                                          ServletException

      Start the HTTP upgrade process and pass the connection to the provided protocol handler once the current request/response pair has completed processing. Calling this method sets the response status to `HttpServletResponse.SC_SWITCHING_PROTOCOLS` and flushes the response. Protocol specific headers must have already been set before this method is called.

      The default behavior of this method is to return `HttpServletRequest.upgrade(Class)` on the wrapped request object.

      Specified by:
        `upgrade` in interface `HttpServletRequest`
      Type Parameters:
        `T` - The type of the upgrade handler
      Parameters:
        `httpUpgradeHandlerClass` - The class that implements the upgrade handler
      Returns:
        A newly created instance of the specified upgrade handler type
      Throws:
        `java.io.IOException` - if an I/O error occurred during the upgrade
        `ServletException` - if the given httpUpgradeHandlerClass fails to be instantiated
      Since:
        Servlet 3.1

    - #### newPushBuilder

          public PushBuilder newPushBuilder()

      Obtain a builder for generating push requests. `PushBuilder` documents how this request will be used as the basis for a push request. Each call to this method will return a new instance, independent of any previous instance obtained.

      The default behavior of this method is to return `HttpServletRequest.newPushBuilder()` on the wrapped request object.

      Specified by:
        `newPushBuilder` in interface `HttpServletRequest`
      Returns:
        A builder that can be used to generate push requests based on this request or `null` if push is not supported. Note that even if a PushBuilder instance is returned, by the time that `PushBuilder.push()` is called, it may no longer be valid to push a request and the push request will be ignored.
      Since:
        Servlet 4.0

    - #### getTrailerFields

          public java.util.Map<java.lang.String,java.lang.String> getTrailerFields()

      Obtain a Map of the trailer fields that is not backed by the request object.

      The default behavior of this method is to return `HttpServletRequest.getTrailerFields()` on the wrapped request object.

      Specified by:
        `getTrailerFields` in interface `HttpServletRequest`
      Returns:
        A Map of the received trailer fields with all keys lower case or an empty Map if no trailers are present
      Since:
        Servlet 4.0

    - #### isTrailerFieldsReady

          public boolean isTrailerFieldsReady()

      Are trailer fields ready to be read (there may still be no trailers to read). This method always returns `true` if the underlying protocol does not support trailer fields. Otherwise, `true` is returned once all of the following are true:
      - The application has ready all the request data and an EOF has been received or the content-length is zero
      - All trailer fields, if any, have been received

      The default behavior of this method is to return `HttpServletRequest.isTrailerFieldsReady()` on the wrapped request object.

      Specified by:
        `isTrailerFieldsReady` in interface `HttpServletRequest`
      Returns:
        `true` if trailers are ready to be read
      Since:
        Servlet 4.0

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.